from collisionsystem import AABB, Point

class Actor:
	def __init__(self, id, pos, sprite, data_manager):
		self.id = id
		self.pos = pos
		self.sprite = sprite
		self.dataManager = data_manager
		
		### AABB
		self.aabb = None
		topleft     = Point(self.pos.x - self.sprite.frameSize.x/2, self.pos.y + self.sprite.frameSize.y/2)
		bottomright = Point(self.pos.x + self.sprite.frameSize.x/2, self.pos.y - self.sprite.frameSize.y/2)
		self.aabb = AABB(topleft, bottomright, self)
		
		
		### Physics
		self.stuck = False
		self.speed = Point(0,0)
		self.acc   = Point(0,0)
		
		### Dont pass through objects
		self.isPhantom = False
		
		self.moveWithCamera = True
		
		self.type = "Normal"
		self.doCollisionTest = True
		
	def update(self, frametime):
		self.sprite.update( frametime )
		
#		topleft     = Point(self.pos.x - self.sprite.frameSize.x/2, self.pos.y + self.sprite.frameSize.y/2)
#		bottomright = Point(self.pos.x + self.sprite.frameSize.x/2, self.pos.y - self.sprite.frameSize.y/2)
#		self.aabb = AABB(topleft, bottomright, self)
	
	def place(self, pos):
		#print "p", pos 
		#print "sp", self.pos
		dist = Point(pos.x - self.pos.x, pos.y - self.pos.y)
		#print "d", dist
		self.move(dist)
			
		
	def move(self, dist):
		self.pos += dist
		for aabb in self.getAABBs():
			aabb.top    += dist.y
			aabb.left   += dist.x
			aabb.bottom += dist.y
			aabb.right  += dist.x
			
	def getAABBs(self):
		if self.aabb is None:
			return []
		return[self.aabb]
	
	def collideWith(self, collisions):
		self.speed = Point(0,0)
		self.acc   = Point(0,0)
		# print 1
		# print "collision!", actor.sprite.image
		
		