from random import *

from collisionsystem import Point
import colors

class EditComponent:
    def __init__(self, data_manager):
        self.dataManager = data_manager
        self.activeActor = None
        self.typeconv = {}
        self.typeconv["bush"] = ("fluff","bush_64.png", "1")
        self.typeconv["tree1"] = ("fluff","tree_512.png", "1")
        self.typeconv["tree2"] = ("fluff","tree_512.png", "2")
        self.typeconv["tree3"] = ("fluff","tree_512.png", "3")
        self.typeconv["tree4"] = ("fluff","tree_512.png", "4")
        self.typeconv["stone_128"] = ("ground","stone_128.png", None)
        self.typeconv["stone_64"] = ("ground","stone_64.png", None)
        self.typeconv["ground_256"] = ("ground","ground_256.png", None)
        self.typeconv["ground_64"] = ("ground","ground_64.png", None)
        self.typeconv["flower1"] = ("fluff","flower_256.png", "1")
        self.typeconv["flower2"] = ("fluff","flower_256.png", "2")
        self.typeconv["flower3"] = ("fluff","flower_256.png", "3")
        self.typeconv["flower4"] = ("fluff","flower_256.png", "4")
        self.typeconv["mush1"] = ("fluff","mush_256.png", "1")
        self.typeconv["mush2"] = ("fluff","mush_256.png", "2")
        self.typeconv["mush3"] = ("fluff","mush_256.png", "3")
        self.typeconv["mush4"] = ("fluff","mush_256.png", "4")
        self.typeconv["integral"] = ("integral","integral.png", "integral")
        self.typeconv["info"] = ("info","info.png", "default_info_text")
        for x in range(1,10):
            self.typeconv[str(x)] = ("powerup", "star.png", str(x))
        
        self.oldtype = ""
    
    def update(self, frameTime):
        if not self.dataManager.inLevelEdit or self.activeActor is None: return
        
        self.activeActor.place(self.dataManager.mousePos)
        self.part[1] = str(int(self.dataManager.mousePos.x))
        self.part[2] = str(int(self.dataManager.mousePos.y))
        #print self.dataManager.mousePos


    def spawnActor(self, type):
        
        if "flower" in self.oldtype and "flower" in type:
            if self.oldtype =="flower1": type = "flower2"
            elif self.oldtype =="flower2": type = "flower3"
            elif self.oldtype =="flower3": type = "flower4"
            elif self.oldtype =="flower4": type = "flower1"
        
        elif "mush" in self.oldtype and "mush" in type:
            if self.oldtype =="mush1": type = "mush2"
            elif self.oldtype =="mush2": type = "mush3"
            elif self.oldtype =="mush3": type = "mush4"
            elif self.oldtype =="mush4": type = "mush1"
        
        elif "tree" in self.oldtype and "tree" in type:
            if self.oldtype =="tree1": type = "tree2"
            elif self.oldtype =="tree2": type = "tree3"
            elif self.oldtype =="tree3": type = "tree4"
            elif self.oldtype =="tree4": type = "tree1"
        
        
        self.oldtype = type
        
        self.dataManager.removeActor(self.activeActor)

        a = self.dataManager.createActor(self.typeconv[type][0], 
                                         self.dataManager.mousePos, 
                                         self.typeconv[type][1], 
                                         self.typeconv[type][2])
        a.shouldColTest = a.doCollisionTest
        a.doCollisionTest = False
        self.activeActor = a
        self.part = [self.typeconv[type][0], 
                     str(int(self.dataManager.mousePos.x)), 
                     str(int(self.dataManager.mousePos.y)),
                     self.typeconv[type][1], 
                     self.typeconv[type][2]]
        print "spawn", type
    
    def placeActor(self):
        if self.activeActor is None: return
        
        self.activeActor.doCollisionTest = self.activeActor.shouldColTest
        if self.activeActor.type == "PowerUp": 
            self.activeActor.poweroff()
            
        name = self.part[0]
        x = self.part[1]
        y = self.part[2]
        image = self.part[3]
        info = self.part[4]
        self.dataManager.currentLevel.addPart(name, x, y, image, info)
        
        self.activeActor = None
        self.part = None
        
        
        print "place"
        
        