import random
from math import *

from collisionsystem import AABB, Point
from actor import Actor
import colors

class InfoActor(Actor): 
	def __init__(self, id, pos, sprite, data_manager):
		Actor.__init__(self, id, pos, sprite, data_manager)
		self.stuck = True
		self.type = "Info"
		self.isPhantom = True

		self.showTime = 4.0
		self.currTime = 0.0
		self.totTime = 0.0
		self.deltay = 0.0
		
		self.infotext = "info"
		self.guitext = None
		self.hasCollided = False
		
		
	def update(self, frametime):
		Actor.update(self, frametime )
		
		self.totTime += frametime
		self.deltay   = 0.3 * sin(self.totTime)
		p = Point(self.pos.x, self.pos.y + self.deltay)
		self.place(p)
		
		if not self.hasCollided:
			return
		
		self.currTime += frametime
		if self.currTime > self.showTime:
			self.guitext.visible = False
			self.dataManager.removeText(self.guitext)
			self.dataManager.removeActor(self)
		
	
	def onCollideWithPlayer(self):
		if self.hasCollided:
			return
		
		self.hasCollided = True
		
		name = self.type + str(id)
		font = "mainFont"
		color = colors.white
		pos = Point(-250, -300)
		
		self.guitext = self.dataManager.createText(name, font, color, pos, self.infotext)

