import pygame
from pygame.locals import *

import level
from collisionsystem import Point

class Input:
	def __init__(self, data_manager):
		self.dataManager = data_manager

	def capture(self):
		
		for event in pygame.event.get():
			### Quitting
			if event.type == QUIT:
				self.dataManager.keepRunning = False
			elif event.type == KEYDOWN and event.key == K_ESCAPE:
				self.dataManager.keepRunning = False
			
			if event.type == KEYDOWN:
				if event.key == K_RETURN or event.key == K_KP_ENTER:
					self.dataManager.menuComponent.activateItem()
				
				elif event.key == K_LEFT:
					self.dataManager.menuComponent.left()		
				elif event.key == K_RIGHT:
					self.dataManager.menuComponent.right()
				elif event.key == K_UP:
					self.dataManager.menuComponent.up()
				elif event.key == K_DOWN:
					self.dataManager.menuComponent.down()

