from random import randint
import os
import data
from collisionsystem import Point

class Level:
	def __init__(self, name, data_manager):
		self.name = name
		self.filename = os.path.join( "levels", name + ".txt")
		self.dataManager = data_manager
		
		self.levelDef = []
		self.staticParts = []
		
		self.finished = False
		self.starttext = ""
		

	def addPart(self, name, x, y, image, info):
		if info is None: 
			info = name
		part = "			".join([name, x, y, image, info])
		self.levelDef.append(part)
		
		
	def start(self):
		print "Starting Level", self.filename
		self.dataManager.clear()
		#self.dataManager.sound.playSound(data.filepath( os.path.join("audio", "tvspelmix.ogg") ) , 1.1)	
		#self.dataManager.sound.playSound(data.filepath( os.path.join("audio", "goblin.s3m") ) , 1.1)	

		self.finished = False
		
		f = data.load(self.filename, "r")
		self.starttext = f.readline()
		for line in f.readlines():
			if line.strip() == "" or line[0] == "#":
				continue
			
			(name, x, y, image, info) = line.split()
			p = Point( int(x), int(y) )
			self.dataManager.createActor( name, p, image, info)
			self.addPart(name, x, y, image, info)
			
				
		### Add water
		for i in range (2):
			a = self.dataManager.createActor("water", Point(-20*i/2 + i*20, -600 -25*i ), "water.png", "apa")
			a.speed.y = 12

	
	def save(self):
		f = data.load(self.filename, "w")
		f.write( self.starttext + "\n" )
		for line in self.levelDef:
			print line
			f.write(line + "\n")
	
class RandomLevel:
	def __init__(self, data_manager):
		self.dataManager = data_manager
		
		
		name = "player"
		image = "theta.png"
		info  = "--"
		p = Point( 0, 200 )
		
		self.dataManager.createActor( name, p, image, info)
		
		
		### grass grounds
		print "grass",
		for x in range (15):
			name = "grass"
			image = "ground_256.png"
			info  = "--"
			
			p = Point( randint(-10,10) * 50, randint(-1, 10) * 150)
			while self.dataManager.getDistToClosestActor(p) < 250:
				p = Point( randint(-10,10) * 50, randint(-1, 10) * 150)
			print x,
			self.dataManager.createActor( name, p, image, info)
			
			### Trees
			if randint(1,10) < 5:
				name = "tree"
				image = "tree.png"
				info  = "--"
				p = Point( p.x, p.y + 75)
				
				self.dataManager.createActor( name, p, image, info)
				
			
		### metal thingies
		print ""
		print "metal",
		for x in range (15):
			name = "metal"
			image = "metal.png"
			info  = "--"
			
			
			p = Point( randint(-10,10) * 50, randint(-1, 10) * 150)
			while self.dataManager.getDistToClosestActor(p) < 200:
				p = Point( randint(-50,50) * 10, randint(-10, 100) * 15)
			

			print x,
			self.dataManager.createActor( name, p, image, info)

		### numbers
		print ""
		print "numbers",
		for x in range (50):
			name = "powerup"
			image = "star.png"
			info  = str(randint(1,9))
			
			
			p = Point( randint(-10,10) * 50, randint(-1, 10) * 150)
			while self.dataManager.getDistToClosestActor(p) < 50:
				p = Point( randint(-10,10) * 50, randint(-1, 10) * 150)
				
			print x,
			
			self.dataManager.createActor( name, p, image, info)
		
		
		