from collisionsystem import AABB, Point
from actor import Actor
from math import *
import random

class MathActor(Actor): 
    def __init__(self, id, pos, sprite, data_manager):
        Actor.__init__(self, id, pos, sprite, data_manager)
        self.stuck = True
        self.type = "PowerUp"
        self.mathsymbol = "1"
        self.tottime = random.random()*100.0
        self.activationTime = 1000000.0
        self.deltay = 0.0
    def setMathSymbol(self, symbol):
        self.mathsymbol = symbol
        self.sprite.setAnimation(symbol)
    
    def poweroff(self):
        self.doCollisionTest = False
        self.sprite.color = (1.0, 1.0, 1.0, 0.5)
        self.activationTime = 7.0
        
    def update(self, frametime):
        Actor.update(self, frametime )
        if self.doCollisionTest:
            dist = Point(0,0)
            self.tottime += frametime
            #print frametime
            self.deltay = 0.3*sin(self.tottime)
            p = Point(self.pos.x, self.pos.y + self.deltay)
            self.place(p)
        else:
            self.activationTime -= frametime
            if self.activationTime <= 0:
                self.doCollisionTest = True
                self.sprite.color = (1.0, 1.0, 1.0, 1.0)
    
