from collisionsystem import AABB, Point
from actor import Actor

class Player(Actor): 
	def __init__(self, id, pos, sprite, data_manager):
		Actor.__init__(self, id, pos, sprite, data_manager)
		
		self.isOnGround = False
		self.isAlive = True
		
	def update(self, frametime):
		Actor.update(self, frametime )	
		
		self.speed.x = max(-250, self.speed.x)
		self.speed.x = min(self.speed.x, 250)
		
		if self.isOnGround: 
			self.acc = self.acc * 0.8
			self.speed = self.speed * 0.8
			
			self.speed.y = max(-100, self.speed.y)
			self.speed.y = min(self.speed.y, 100)
			#self.acc *= 0.1# Point(0,0)
			pass
		
		runspeed = 4
		jumpspeed = 4
		if abs(self.speed.y) > jumpspeed:
			self.sprite.setAnimation("jump")
		elif abs(self.speed.x) > runspeed:
			self.sprite.setAnimation("run")
		else:
			self.sprite.setAnimation("stand")
		
		
	def collideWith(self, collisions):
		#print "collision!", self.sprite.image, collisions
		
		if len(collisions[self.aabb]) == 0:
			self.isOnGround = False
			return
			
		for my_aabb, other_aabb, direction in collisions[self.aabb]:
			other_actor = other_aabb.owner
			if other_actor.type == "PowerUp":
				self.dataManager.mathComponent.addSymbol(other_actor.mathsymbol)
				other_actor.poweroff()
				#self.dataManager.removeActor(other_actor)
				#print self.mathsymbols
			elif other_actor.type == "Normal":
				self.dataManager.playerCollided()
				if direction.y != 0:
					self.speed.y = 0
					self.acc.y = 0
					if direction.y > 0:
						self.isOnGround = True
					else:
						self.isOnGround = False
						self.acc.x = 0
				elif direction.x != 0:
					self.speed.x = 0
					self.acc.x = 0
				else:
					print "wtf"
					
			elif other_actor.type == "Water":
				self.dataManager.playerCollided()
				#self.dataManager.keepRunning = False
				self.isAlive = False
			elif other_actor.type == "Integral":
				self.dataManager.currentLevel.finished = True
			elif other_actor.type == "Info":
				other_actor.onCollideWithPlayer()

			
		