import math

use_sound = True
try:
	import pySonic
except:
	print "Couldn't import pySonic, no sound will be used!"
	use_sound = False

class Sound:
	def __init__(self, data_manager):
		self.dataManager = data_manager
		
		if not use_sound:
			return
		
		### init pysonic
		# initialize fmod
		self.w = pySonic.World()
		self.w.RolloffFactor = 0.5
		#src = pySonic.Source()
		#print self.w.Driver
		#print self.w.Output
		#print self.w.Mixer
		
		self.song = None
		self.sources = []
		self.freqs = {}
		
		self.freq = 44000
		self.speed = self.dataManager.gameSpeed
		
	def update(self, frametime):
		if not use_sound:
			return
		
		if self.speed != self.dataManager.gameSpeed:
			self.speed = self.speed + (self.dataManager.gameSpeed - self.speed) * 0.2
			self.speed = max(self.speed, 0.1)

			self.freq = int(44000 * math.sqrt(self.speed))
			#print "freq", self.freq
			
			try:
				self.song.UserSpeed = self.speed
			except:
				# wasn't a song, it was actually  just a sound
				self.song.Frequency = self.freq
			
			
			for src in self.sources:
				#print "changind freq to", self.freq, "for", src.Sound
				src.Frequency = int(self.freq * self.freqs[src])
	
	def playSong(self, sound, freq_factor = 1.0):
		if not use_sound:
			return
		
		try:
			self.song = pySonic.Song(sound)
			self.song.Play()
			self.song.Looping = True
			print "Playing song", sound
		except:
			#print "couldn't play", sound, "as song"
			self.song = self.playSound( sound, freq_factor, loop = True )
		
	def playSound(self, sound, freq_factor = 1.0, loop = True):
		if not use_sound:
			return
		
		src = pySonic.Source()
		src.Sound = pySonic.FileSample(sound)
		src.Frequency = int(self.freq * freq_factor)
		src.LoopMode = loop
		
		#src.Position = (0,0,0)
		src.SetEndStreamCallback(self.onEndStream)
		self.sources.append(src)
		self.freqs[src] = freq_factor
		
		src.Play()
		return src
	
	def onEndStream(self, source):
		
		if not use_sound:
			return
		
		source.Play()
		#if not source.LoopMode:
			#self.sources.remove(source)
		
	def clear(self):
		if not use_sound:
			return
		
		#for src in self.sources:
		#	if src is not self.song:
		#		src.Stop()
		
		#try:
		#	self.song.Stop()
		#except:
		#	pass
		
		#self.sources = []
		#self.freqs = {}
		self.freq = 44000
		
		